/******************************/
/* LN^f[^ϊ */
/******************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#define	CHRWIDTH	32
#define	CHRHEIGHT	16
#define	MAXCHARA	128

int main(int argc, char **argv)
{
	FILE	*infp;
	FILE	*outfp;
	FILE	*patfp;

	int		pixel[CHRWIDTH][CHRHEIGHT][MAXCHARA];
	int		c_pixel[CHRWIDTH/2][CHRHEIGHT][MAXCHARA];

	int		width,height;
	int		x,y,z,c;
	int		i,j;
	int		sft;
	int		a0,a1;
	int		size;
	int		chw,chh,pl;
	int		cnum;
	int		offset;

	if (argc != 6) {
		fprintf(stderr, "Usage: convchara infile outfile size cha_number offset\n");
		exit(1);
	}

/* open files */

	if ((infp = fopen(argv[1], "rb")) == NULL) {
		perror(argv[1]);
		exit(1);
	}

	if ((outfp = fopen(argv[2], "wb")) == NULL) {
		perror(argv[2]);
		exit(1);
	}

	size = atoi(argv[3]);

	if (size == 1) {
		chw = 16;
		chh = 8;
		pl  = 2;
	} else if (size == 2) {
		chw = 32;
		chh = 16;
		pl  = 2;
	} else if (size == 3) {
		chw = 32;
		chh = 16;
		pl  = 1;
	} else if (size == 4) {
		chw = 32;
		chh = 16;
		pl  = 3;
	} else {
		fprintf(stderr, "Illigal size %d\n",size);
		exit(1);
	}

	cnum = atoi(argv[4]);
	offset = atoi(argv[5]);

	fseek(infp,offset,SEEK_SET);

	for (z = 0;z < MAXCHARA;z ++) {
		for (y = 0;y < chh;y ++) {
			for (x = 0;x < chw;x ++) {
				pixel[x][y][z] = 0x08;
			}
		}
	}

	z = 0;
	y = 0;
	x = 0;

	if (pl == 1) {
		c =  0x0c;
	} else if (pl == 2) {
		c = 0x09;
	} else {
		c = 0x09;
	}

	while ( (a0 = fgetc(infp)) != EOF) {

		sft = 0x80;
		for (i = 0;i < 8;i ++) {
			a1 = ( (a0 & sft) != 0x00) ? c : 0x08;
			pixel[x+i][y][z] |= a1;
			sft /= 2;
		}

		x += 8;
		if (x >= chw) {
			x = 0;
			y ++;
			if (y >= chh) {
				y = 0;
				if (c == 0x09) {
					c = 0x0a;
				} else if (c == 0x0a) {

					if (pl == 2) {
						c = 0x09;
						z ++;

						if (z >= cnum) {
							break;
						}
					} else {
						c = 0x0c;
					}

				} else {		// c == 0x0c

					if (pl == 3) {
						c = 0x09;
					}

					z ++;
					if (z >= cnum) {
						break;
					}

				}

			}
		}
	}

	for (z = 0;z < cnum;z ++) {
		for (y = 0;y < chh;y ++) {
			for (x = 0;x < chw;x ++) {
				if (pl != 3) {
					switch (pixel[x][y][z]) {
						case 0x08: pixel[x][y][z] = 0x08;break;
						case 0x09: pixel[x][y][z] = 0x09;break;
						case 0x0a: pixel[x][y][z] = 0x0a;break;
						case 0x0b: pixel[x][y][z] = 0x0f;break;
						case 0x0c: pixel[x][y][z] = 0x0e;break;
						default:   pixel[x][y][z] = 0x08;break;
					}
				} else {
					switch (pixel[x][y][z]) {
						case 0x08: pixel[x][y][z] = 0x08;break;		/*      */
						case 0x09: pixel[x][y][z] = 0x0a;break;		/*  */
						case 0x0a: pixel[x][y][z] = 0x09;break;		/*      */
						case 0x0b: pixel[x][y][z] = 0x09;break;		/*  */
						case 0x0c: pixel[x][y][z] = 0x0a;break;		/* ΁ */
						case 0x0d: pixel[x][y][z] = 0x0a;break;		/*      */
						case 0x0e: pixel[x][y][z] = 0x0f;break;		/*  */
						case 0x0f: pixel[x][y][z] = 0x0f;break;		/*      */
						default:   pixel[x][y][z] = 0x08;break;
					}
				}
			}
		}
	}


	for (z = 0;z < cnum;z ++) {
		for (x = 0;x < chw;x += 8) {
			for (y = 0;y < chh;y ++) {

				if (pl == 2 || pl == 3) {

					a1 = 0;
					for (i = 0;i < 8;i ++) {
						a0 = ( ((pixel[x+i][y][z] & 0x02) != 0x00) ? 0x01 : 0x00);
						a1 = a1 * 2 + a0;
					}
					fputc(a1,outfp);

					a1 = 0;
					for (i = 0;i < 8;i ++) {
						a0 = ( ((pixel[x+i][y][z] & 0x01) != 0x00) ? 0x01 : 0x00);
						a1 = a1 * 2 + a0;
					}
					fputc(a1,outfp);

				} else {

					a1 = 0;
					for (i = 0;i < 8;i ++) {
						a0 = ( ((pixel[x+i][y][z] & 0x04) != 0x00) ? 0x01 : 0x00);
						a1 = a1 * 2 + a0;
					}
					fputc(a1,outfp);

				}

			}
		}

		if (pl == 3) {
			for (x = 0;x < chw;x += 8) {
				for (y = 0;y < chh;y ++) {
					fputc(0x00,outfp);
				}
			}
		}

	}



	fclose(outfp);
	fclose(infp);

	return(0);
}

